﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using Microsoft.VisualBasic;
using System.Diagnostics;
using System.Threading;
using System.Windows.Forms;

namespace NoteWrapper
{
    public class NotePad
    {
        private const string location = "NotePad.exe";
        private Process NPad;
        public event EventHandler Exited;
        public NotePad()
        {

            Int32 ProcessHandle = Interaction.Shell(
                        location,
                    AppWinStyle.NormalFocus,
                    false, 0);
            NPad = Process.GetProcessById(ProcessHandle);
            NPad.EnableRaisingEvents = true;
            NPad.Exited += new EventHandler(Npad_Exited);
        }
        public void Input(string Text)
        {

            if (NPad.Responding)
            {

                Interaction.AppActivate(NPad.Id);
                Thread.Sleep(10);

                SendKeys.SendWait(Text);

            }

        }
        void Npad_Exited(object sender, EventArgs e)
        {
            /*
                    if (Exited != null)
                    {
                        Exited(this, e);
                    }
                }
                     */
            Control target;
            object[] param = new object[2];
            param[0] = this;
            param[1] = e;
            Delegate[] List = Exited.GetInvocationList();
            foreach (Delegate d in List)
            {
                target = d.Target as Control;
                if (target != null)
                {

                    target.Invoke(d, param);

                }

                else
                {

                    d.DynamicInvoke(param);

                }


            }
        }
    }
}
